#include <stdio.h>

#include <stdlib.h>

#include <math.h>

#include "common1.h"

#include "common3.h"



  void make_a_matrix(int,struct mat **,double *);

  void make_t_matrix(struct mat ***,struct mat ***,double *);

  void make_cost(int,double *);

  void putmat(struct mat **,int,int,double);

  void write_problem_file();



  int main()

{

  struct mat ***a,***t0,***t1;

  double **b,*ev;

  int i,n,k,nc;



  init_param();

  read_file();

  write_data();

  init_num();



  b=m_darr2(LR,IR);

  c=m_darr2(LR,JC);

  ev=m_darr1(KE);

  a=m_marr2(LR,JC);

  t0=m_marr2(LR,JC);

  t1=m_marr2(LR,JC);



  climate(0,co2emi,tsoxemi);



  for(n=0;n<LR;n++) {

    make_a_matrix(n,a[n],b[n]); 

    make_cost(n,c[n]);

  }

  make_t_matrix(t0,t1,ev); 



  write_problem_file(a,t0,t1,b,ev,islack,kslack);



  return(0);

}



  void write_problem_file(a,t0,t1,b,ev,islack,kslack)

  struct mat ***a,***t0,***t1;

  double **b,*ev;

  int *islack,*kslack;

{ int i,j,n,k,nc;

  struct mat *pt;

  FILE *fp;



  fp=fopen("cnst.tmp","w");



  fprintf(fp,"%6d\n",LR);

  fprintf(fp,"%6d\n",IR);

  fprintf(fp,"%6d\n",JC);

  fprintf(fp,"%6d\n",KEL);

  fprintf(fp,"%5d\n",N_BLK);

  fprintf(fp,"%6d\n",KE);

  fprintf(fp,"%6d\n",IINTER);



  nc=0;

  for(n=0;n<LR;n++){

    for(i=0;i<JC;i++) {

      pt=a[n][i];

      while(pt!=NULL) {

        nc++;

        pt=pt->next;

      }

    }

  }

  fprintf(fp,"%6d\n",nc);

  for(n=0;n<LR;n++){

    for(i=0;i<JC;i++) {

      pt=a[n][i];

      while(pt!=NULL) {

        fprintf(fp,"%2d %5d %5d %16.13g\n",n,i,pt->row,pt->val);

        pt=pt->next;

      }

    }

  }

  nc=0;

  for(n=0;n<LR;n++){

    for(i=0;i<JC;i++) {

      pt=t0[n][i];

      while(pt!=NULL) {

        nc++;

        pt=pt->next;

      }

    }

  }

  fprintf(fp,"%6d\n",nc);

  for(n=0;n<LR;n++){

    for(i=0;i<JC;i++) {

      pt=t0[n][i];

      while(pt!=NULL) {

        fprintf(fp,"%2d %5d %5d %16.13g\n",n,i,pt->row,pt->val);

        pt=pt->next;

      }

    }

  }



  nc=0;

  for(n=0;n<LR;n++){

    for(i=0;i<JC;i++) {

      pt=t1[n][i];

      while(pt!=NULL) {

        nc++;

        pt=pt->next;

      }

    }

  }

  fprintf(fp,"%6d\n",nc);

  for(n=0;n<LR;n++){

    for(i=0;i<JC;i++) {

      pt=t1[n][i];

      while(pt!=NULL) {

        fprintf(fp,"%2d %5d %5d %16.13g\n",n,i,pt->row,pt->val);

        pt=pt->next;

      }

    }

  }





  for(n=0;n<LR;n++){

    for(i=0;i<IR;i++) 

      fprintf(fp,"%16.13g\n",b[n][i]);

  }



  for(i=0;i<KE;i++) 

    fprintf(fp,"%16.13g\n",ev[i]);



  for(n=0;n<LR;n++)

    for(i=0;i<JC;i++)

      fprintf(fp," %16.13g\n",c[n][i]);



  for(i=0;i<IR;i++) 

    fprintf(fp,"%2d\n",islack[i]);



  for(i=0;i<KE;i++) 

    fprintf(fp,"%2d\n",kslack[i]);



  fclose(fp);



  fp=fopen("eval.tmp","w");

  fprintf(fp,"%4d\n",ictrl1);

  fprintf(fp,"%4d\n",ictrl6);

  fprintf(fp,"%4d\n",ictrl8);

  fprintf(fp,"%4d\n",N_REN-2);

  fprintf(fp,"%4d\n",N_DEM);

  fprintf(fp,"%4d\n",N_RGRADE);

  fprintf(fp,"%5d\n",N_TIME);

  for(i=0;i<N_REN-2;i++) {

    for(k=0;k<N_BLK;k++)

      fprintf(fp,"%4d ",jc[3][i][0][k]);

    fprintf(fp,"\n");

  }

  for(i=0;i<N_DEM;i++) {

    for(k=0;k<N_BLK;k++)

      fprintf(fp,"%4d ",jc[6][0][i][k]);

    fprintf(fp,"\n");

  }

  for(k=0;k<N_BLK;k++)

    fprintf(fp,"%4d ",jc[6][2][0][k]);

  fprintf(fp,"\n");

  for(k=0;k<N_BLK;k++)

    fprintf(fp,"%4d ",jc[6][3][0][k]);

  fprintf(fp,"\n");

  for(n=0;n<LR;n++) 

    fprintf(fp,"%16.13g\n",f_off_set[n]);



  for(n=0;n<LR;n++)

    for(i=0;i<N_REN-2;i++)

      for(j=0;j<N_RGRADE;j++)

        for(k=0;k<N_BLK;k++)

  fprintf(fp," %16.13g  %16.13g\n",slope_f[n][i][j][k],slope_df[n][i][j][k]);



  for(n=0;n<LR;n++)

    for(i=0;i<N_REN-2;i++)

      for(j=0;j<N_RGRADE;j++)

         fprintf(fp," %16.13g\n",rgdk[n][i][j]);



  for(n=0;n<LR;n++)

    for(i=0;i<N_REN-2;i++)

      for(j=0;j<N_RGRADE+1;j++)

        for(k=0;k<N_BLK;k++)

          fprintf(fp," %16.13g\n",rpck[n][i][j][k]);



  for(n=0;n<LR;n++)

    for(k=0;k<N_BLK;k++)

      fprintf(fp,"%16.13g\n",damage[n][k]);



  for(n=0;n<LR;n++)

    fprintf(fp," %16.13g\n",mepm[n][5]);



  for(n=0;n<LR;n++)

    for(i=0;i<N_DEM;i++)

      for(k=0;k<N_BLK;k++)

         fprintf(fp," %16.13g %16.13g %16.13g %16.13g\n"

     ,rdemak[n][i][k],cdemak[n][i][k],enecon_f[n][i][k],prod_b[n][i][k]);



  for(n=0;n<LR;n++)

    for(i=0;i<N_DEM;i++)

      fprintf(fp," %16.13g\n",prelas[n][i]);



  for(n=0;n<LR;n++)

    fprintf(fp," %16.13g %16.13g\n",enelas[n],klelas[n]);



  for(n=0;n<LR;n++)

    for(k=0;k<N_BLK;k++)

       fprintf(fp," %16.13g %16.13g %16.13g %16.13g\n"

     ,rkap[n][k],kapk[n][k],prod_a[n][k],prod_c[n][k]);



  for(k=0;k<N_BLK;k++)

    fprintf(fp," %16.13g \n",dis_f[n_tm[k]]*prob_k[k]);

 



  fclose(fp);



}





  void make_t_matrix(t0,t1,ev)

  struct mat ***t0,***t1;

  double *ev;

{ int i,j,k,l,n,pindex,k0,j0;

  double v;

  struct mat *pt,*pt0;

  FILE *fp;



  for(k=0;k<KE;k++) ev[k]=0.;



  for(n=0;n<LR;n++) {

    for(k=0;k<N_BLK;k++) {

      pindex=KEL*k;

      for(j=0;j<IINTER;j++) {

        for(i=0;i<LR;i++) {

          j0=jc[0][j][i][k];

          if(i!=n) {

            putmat(t0[n],i+j*LR+pindex,j0,-1.);

            putmat(t1[n],j*LR+pindex,j0,-1.);

    }

          else{

            putmat(t0[n],i+j*LR+pindex,j0,1.);

            putmat(t1[n],j*LR+pindex,j0,1.);

    }

  }

      }

      pindex=KEL*k+IINTER*LR;

      for(i=0;i<ITRANS;i++) {

        putmat(t0[n],pindex+i,jc[1][i][0][k],-1.);

        putmat(t0[n],pindex+i,jc[1][i][1][k],1.);

        putmat(t1[n],pindex+i,jc[1][i][0][k],-1.);

        putmat(t1[n],pindex+i,jc[1][i][1][k],1.);

      }

    }

  }



/*    CO2 Concentration Constraint */



  if(ictrl4==1) {

    for(k=0;k<N_BLK;k++) {

      l=0;

      while(n_sc[l][k]==0) {l++;}

      if(co2con[l][n_tm[k]]>=0.) {

        pindex=KEL*k+IINTER*LR+ITRANS+LR;

        ev[pindex]=(co2con[l][n_tm[k]]+d_const[0][l][n_tm[k]])*1000.;

        k0=k;

        do {

          v=d_coeff[0][l][n_tm[k]][n_tm[k0]];

          for(n=0;n<LR;n++) {

            putmat(t0[n],pindex,jc[6][1][0][k0],v);

            putmat(t0[n],pindex,jc[6][1][1][k0],-v);

            putmat(t1[n],pindex,jc[6][1][0][k0],v);

            putmat(t1[n],pindex,jc[6][1][1][k0],-v);

    }

          k0=inc_mat[0][k0];

        } while(k0!=-1);

      }

    }

  }



/*    Temperature Rises Constraint */



  if(ictrl5||ictrl7) {

  if(ictrl11==0){

      for(i=0;i<LR;i++) {

        rtmpc[i]=1.;

        for(n=0;n<LR;n++)rtmps[n][i]=1.;

    }

  }



    for(k=0;k<N_BLK;k++) {

      l=0;

      while(n_sc[l][k]==0) {l++;}

      if((ictrl5&&temper[l][n_tm[k]]>=0.)||ictrl7) {

        for(i=0;i<LR;i++) {

          pindex=KEL*k+IINTER*LR+ITRANS+i;

          v=rtmpc[i]*d_const[2][l][n_tm[k]];

          for(n=0;n<LR;n++) 

            v+=soxemi[l][n][n_tm[k]+1]/tsoxemi[l][n_tm[k]+1]

              *d_const[3][l][n_tm[k]]*rtmps[n][i];

        ev[pindex]=v*1.e5;

          k0=k;

          putmat(t0[i],pindex,jc[6][2][0][k0],-1.);

          putmat(t1[i],pindex,jc[6][2][0][k0],-1.);

          putmat(t0[i],pindex,jc[6][2][1][k0],1.);

          putmat(t1[i],pindex,jc[6][2][1][k0],1.);

          do {

            v=d_coeff[2][l][n_tm[k]][n_tm[k0]]*rtmpc[i];

            for(n=0;n<LR;n++)

              v+=soxemi[l][n][n_tm[k]+1]/tsoxemi[l][n_tm[k]+1]

               *d_coeff[3][l][n_tm[k]][n_tm[k0]]*rtmps[n][i];

            v*=100.;

            for(n=0;n<LR;n++) {

              putmat(t0[n],pindex,jc[6][1][0][k0],v);

              putmat(t0[n],pindex,jc[6][1][1][k0],-v);

              putmat(t1[n],pindex,jc[6][1][0][k0],v);

              putmat(t1[n],pindex,jc[6][1][1][k0],-v);

      }

            k0=inc_mat[0][k0];

          } while(k0!=-1);

        }

      }

    }

  }

}



  void make_a_matrix(n,ma,mb)

  int n;

  double *mb;

  struct mat **ma;

{ int i,j,k,l,i0,j0,ky0,k1,k2;

  int iep[5]={1,2,3,7,8};

  int ich[19]={0,1,2,3,4,5,6,7,8,9,10,11,12,12,12,13,14,15,16};

  double elesh[3]={1.,1./2.,1./3.};

  double u,v,dsum,dyr,ddyr,dshare[3],wel;

  double **trf,**tre,*elef,*tdl,trc[2],trd[2],u1,u2;

  double thred,ref_cap;



  elef=m_darr1(N_EPLNT);

  tdl=m_darr1(7);

  trf=m_darr2(IINTER,LR);

  tre=m_darr2(IINTER,LR);



  for(j=0;j<IR;j++) mb[j]=0.;



/******************************************

            preprocess

*******************************************/



  for(k=0;k<N_TIME;k++) {

    inv0[n][k]=ivs0[n][k]*gdp0[n][k];

    if(k==0) {

      kap0[n][k]=(dis_i3[n][k]*mepm[n][2]+dis_i1[n][k]*ivs_2000[n])*gdp_2000[n]

          +dis_i2[n][k]*inv0[n][k];

    }

    else {

      kap0[n][k]=dis_i3[n][k]*kap0[n][k-1]

       +inv0[n][k]*dis_i2[n][k]+inv0[n][k-1]*dis_i1[n][k];

    }

  }

  for(k=0;k<N_TIME;k++) kap0[n][k]/=1000.;



  for(i=0;i<N_DEM;i++)

    prelas[n][i]=1./elast[n][i];

  klelas[n]=1.-1./mepm[n][1];

  enelas[n]=1.-1./mepm[n][3];



  dsum=0.;

  for(i=0;i<3;i++) dsum+=dulfel[n][i];

  for(i=0;i<3;i++) dshare[i]=dulfel[n][i]/dsum;



  cem_2000[n]=0.;

  for(i=0;i<N_FOS;i++)

    cem_2000[n]+=co2cef[i+1]*(prtrad[n][i]+currpr[n][i]);



  thred=24.;

  ref_cap=0.;

  for(i=0;i<N_REFO;i++) ref_cap+=refore[n][0]*refore[n][2+i];



/******************************************

       making system matrix

******************************************/



  for(k=0;k<N_BLK;k++) {

    ky0=n_tm[k];

    k1=inc_mat[0][k];

    k2=inc_mat[1][k];



    if(ky0==0) dyr=n_yr[ky0]-start_yr;

    else      dyr=n_yr[ky0]-n_yr[ky0-1];

    if(ky0>1)  ddyr=n_yr[ky0]-n_yr[ky0-2];



  /* Thermal Efficiency */

    for(i=0;i<N_EPLNT;i++) elef[i]=elcoef[i][ky0]*etcon;



  /* Modification for Conventional Fossil Fuel Fired */

    for(i=1;i<4;i++) elef[i]*=relaef[i-1][n][ky0];



  /* Distribution Losses of Electricity */

    for(i=0;i<7;i++) tdl[i]=1./(1.-tdloss[n][i][ky0]);



  /* Conversion Coefficient of Water Electrolysis */

    wel=chcoef[JP_W_ELEC][0][ky0]/etcon;



  /* Capacity Usage Rates of Nuclear Power Plant */

    plcost[7][0]=nclurt[n][ky0];



  /* transportation loss */



    for(i=0;i<LR;i++) {

      if(i!=n) {

        u1=-trocea[n][i];

        u2=-trland[n][i]; 

        for(j=0;j<3;j++) {

          if(j<2) {

            v=pow(1.-trnlos[2*j][ky0],u1)*pow(1.-trnlos[2*j+1][ky0],u2);

            u=0.;

    }

          else {

            v=pow(co2ene[2][0][ky0],u2);

            u=co2ene[2][1][ky0]*u2;

            if(fabs(u2)>0.01) {

              v/=co2ene[1][0][ky0];

              u-=co2ene[1][1][ky0];

      }

    }

          if(fabs(u1)>0.01) {

            v/=chcoef[JP_H2_LIQ+j][0][ky0];

            u-=chcoef[JP_H2_LIQ+j][1][ky0];

    }

          trf[j][i]=v;

          tre[j][i]=v*u/3.;

  }

      }

      else {

        for(j=0;j<3;j++) {

          trf[j][i]=-1.;

          tre[j][i]=0.;

  }

      }

    }



    u1=-trnco2[n][0];

    u2=-trnco2[n][1];



    trc[0]=pow(co2ene[2][0][ky0],u1)/co2ene[1][0][ky0]/co2ene[0][0][ky0];

    trd[0]=trc[0]*(co2ene[2][1][ky0]*u1-co2ene[1][1][ky0]-co2ene[0][1][ky0])/3.;



    v=pow(co2ene[2][0][ky0],u2);

    u=co2ene[2][1][ky0]*u2;

    if(fabs(u2)>0.01) {

      v/=co2ene[1][0][ky0];

      u-=co2ene[1][1][ky0];

    }

    if(fabs(trnco2[n][2])>0.01) {

      v/=chcoef[JP_C2_LIQ][0][ky0];

      u-=chcoef[JP_C2_LIQ][1][ky0];

    }

    trc[1]=v;

    trd[1]=v*u/3.;



/******************************************

            Hydrogen Balance

******************************************/

    j0=ir[1][0][0][k];

/* Trade */

    for(i=0;i<LR;i++) putmat(ma,j0,jc[0][0][i][k],-trf[0][i]);



/* Consumption */

    for(i=0;i<4;i++) putmat(ma,j0,jc[5][0][i][k],-tdl[0]);

    putmat(ma,j0,jc[7][0][5][k],-tdl[0]);



/* Production */

    putmat(ma,j0,jc[7][0][4][k],1.);

    putmat(ma,j0,jc[5][6][1][k],wel);

    for(i=0;i<3;i++) putmat(ma,j0,jc[7][2][i][k],wel);



/******************************************

          Natural Gas Balance

*******************************************/

    j0=ir[1][0][1][k];

/* Trade */

    for(i=0;i<LR;i++) putmat(ma,j0,jc[0][1][i][k],-trf[1][i]);



/* Consumption */

    for(i=0;i<5;i++) putmat(ma,j0,jc[5][1][i][k],-tdl[1]);



/* Production */

    for(i=0;i<N_EGRADE;i++) putmat(ma,j0,jc[2][0][i][k],1.);

    putmat(ma,j0,jc[7][0][0][k],1.);

    putmat(ma,j0,jc[5][3][7][k],chcoef[JP_COAL_L][1][ky0]);



    mb[j0]=demand[n][0][ky0]*shfdsk[n][0]*tdl[1];

/******************************************

        Recoverd CO2 Balance 

*******************************************/

    j0=ir[1][0][2][k];



/* Trade */

    for(i=0;i<LR;i++) putmat(ma,j0,jc[0][2][i][k],-trf[2][i]);



/* Recycle */

    putmat(ma,j0,jc[7][0][7][k],-1.);



/* Disposal */

    for(i=0;i<N_DCO2-1;i++) putmat(ma,j0,jc[2][4][i][k],-trc[0]);

    putmat(ma,j0,jc[2][4][N_DCO2-1][k],-trc[1]);



/* Recovery */

    putmat(ma,j0,jc[7][0][6][k],chcoef[JP_CO2R_P][0][ky0]);

    for(i=3;i<6;i++)

       putmat(ma,j0,jc[5][3][i][k],co2cef[3]*chcoef[JP_CO2R_P][0][ky0]);

    for(i=0;i<3;i++)

       putmat(ma,j0,jc[7][1][i][k],chcoef[JP_CO2R_C][0][ky0]);



/******************************************

               Oil Balance

*******************************************/

    j0=ir[1][0][3][k];

/* Trade */

    putmat(ma,j0,jc[1][0][0][k],-1.);

    putmat(ma,j0,jc[1][0][1][k],1.);



/* Consumption */

    v=-tdl[2]/chcoef[JP_OIL_DI][0][ky0];

    for(i=0;i<7;i++)

      if(i!=3)

        putmat(ma,j0,jc[5][2][i][k],v);

    putmat(ma,j0,jc[5][2][3][k],v/chcoef[JP_OIL_GA][0][ky0]);



/* Production */

    for(i=0;i<N_EGRADE;i++) putmat(ma,j0,jc[2][1][i][k],1.);

    putmat(ma,j0,jc[2][4][0][k],co2sub[0]);

    putmat(ma,j0,jc[2][4][1][k],co2sub[0]);



/******************************************

         Synthesized Oil Balance

*******************************************/

    j0=ir[1][0][10][k];

/* Trade */

    putmat(ma,j0,jc[1][5][0][k],-1.);

    putmat(ma,j0,jc[1][5][1][k],1.);



/* Consumption */

    v=-tdl[2]/chcoef[JP_OIL_DI][0][ky0];

    for(i=0;i<7;i++)

      if(i!=3)

        putmat(ma,j0,jc[5][7][i][k],v);

    putmat(ma,j0,jc[5][7][3][k],v/chcoef[JP_OIL_GA][0][ky0]);



/* Production */

    putmat(ma,j0,jc[5][3][7][k],chcoef[JP_COAL_L][0][ky0]);

    putmat(ma,j0,jc[5][4][4][k],chcoef[JP_BIOM_L][0][ky0]);



/******************************************

           Feed Stock Balance

*******************************************/

    j0=ir[1][0][11][k];

    putmat(ma,j0,jc[5][2][6][k],1.);

    putmat(ma,j0,jc[5][7][6][k],1.);



    mb[j0]=shfdsk[n][1]*demand[n][1][ky0];



/******************************************

           Sulphur Balance 

*******************************************/

    j0=ir[1][0][12][k]; 

  /* Emissions from coal fired power plants */

    for(i=0;i<3;i++)

      putmat(ma,j0,jc[5][3][i][k],-sulcef[0]);

  /* 99% desulphur on IGCC, coal liquefaction and the gasification */

    for(i=3;i<8;i++)

      putmat(ma,j0,jc[5][3][i][k],-sulcef[0]*0.01);

  /* Emissions from final demands of coal */

    putmat(ma,j0,jc[5][3][8][k],-sulcef[0]);

    for(i=0;i<4;i++)

      putmat(ma,j0,jc[7][4][i][k],1.);

    for(i=0;i<3;i++)

      putmat(ma,j0,jc[7][5][i][k],1.);



  /* Emissions from crude oil */

    for(i=0;i<7;i++)

      putmat(ma,j0,jc[5][2][i][k],-sulcef[1]);

    for(i=0;i<4;i++)

      putmat(ma,j0,jc[7][6][i][k],1.);

    for(i=0;i<2;i++)

      putmat(ma,j0,jc[7][7][i][k],1.);



    putmat(ma,j0,jc[6][4][0][k],1.);



/******************************************

              Coal Balance

*******************************************/

    j0=ir[1][0][4][k];

/* Trade */

    putmat(ma,j0,jc[1][1][0][k],-1.);

    putmat(ma,j0,jc[1][1][1][k],1.);

/* Consumption */

    for(i=0;i<9;i++) putmat(ma,j0,jc[5][3][i][k],-tdl[3]);

/* Production */

    for(i=0;i<N_EGRADE;i++) putmat(ma,j0,jc[2][2][i][k],1.);



    mb[j0]=tdl[3]*demand[n][2][ky0]*shfdsk[n][2];



/******************************************

          Methanol Balance

*******************************************/

    j0=ir[1][0][5][k];

/* Trade */

    putmat(ma,j0,jc[1][2][0][k],-1.);

    putmat(ma,j0,jc[1][2][1][k],1.);

/* Consumption */

    for(i=0;i<6;i++) putmat(ma,j0,jc[5][5][i][k],-tdl[5]);

/* Production */

    putmat(ma,j0,jc[7][0][1][k],1.);

    putmat(ma,j0,jc[7][0][8][k],1.);



/******************************************

          CO2 Balance

*******************************************/

    j0=ir[1][0][6][k];

 /* trade */

    for(i=0;i<LR;i++)

      if(i!=n) putmat(ma,j0,jc[0][1][i][k],co2cef[1]);

      else     putmat(ma,j0,jc[0][1][i][k],-co2cef[1]);

    for(i=0;i<LR;i++)

      if(i!=n) putmat(ma,j0,jc[0][2][i][k],1.);

      else     putmat(ma,j0,jc[0][2][i][k],-1.);



    putmat(ma,j0,jc[1][0][0][k],co2cef[2]);

    putmat(ma,j0,jc[1][5][0][k],co2cef[2]);

    putmat(ma,j0,jc[1][1][0][k],co2cef[3]);

    putmat(ma,j0,jc[1][2][0][k],co2cef[5]);

    putmat(ma,j0,jc[1][0][1][k],-co2cef[2]);

    putmat(ma,j0,jc[1][5][1][k],-co2cef[2]);

    putmat(ma,j0,jc[1][1][1][k],-co2cef[3]);

    putmat(ma,j0,jc[1][2][1][k],-co2cef[5]);



  /* Primary Energy Production */

    for(i=0;i<N_FOS;i++) 

      for(j=0;j<N_EGRADE;j++)

        putmat(ma,j0,jc[2][i][j][k],-co2cef[i+1]*rco2cef[i][j]);



 /* CO2 Disposal */

    u=1.-co2cef[2]*co2sub[0];

    putmat(ma,j0,jc[2][4][0][k],u);

    putmat(ma,j0,jc[2][4][1][k],u);

    for(i=2;i<N_DCO2;i++)

      putmat(ma,j0,jc[2][4][i][k],1.);



 /* Reforestation */

  for(i=0;i<N_REFO;i++) putmat(ma,j0,jc[2][5][i][k],1.);

    if(ky0>0 && dyr<thred) 

      for(i=0;i<N_REFO;i++) putmat(ma,j0,jc[2][5][i][k1],1.);

    if(ky0>1 && ddyr<thred) 

      for(i=0;i<N_REFO;i++) putmat(ma,j0,jc[2][5][i][k2],1.);



    putmat(ma,j0,jc[6][1][0][k],1.);

    putmat(ma,j0,jc[6][1][1][k],-1.);



/*******************************************

          Biomass Balance

******************************************/

 /* Biomass balances for major stream (Wood etc)*/

    j0=ir[1][0][7][k];

    for(i=3;i<6;i++) putmat(ma,j0,jc[5][4][i][k],-tdl[4]);/* Consumption */

    putmat(ma,j0,jc[5][4][13][k],-1.);                /* For Elec Gene*/

    putmat(ma,j0,jc[5][4][9][k],1.);                      /*From Energy crops*/

    for(i=5;i<18;i++) putmat(ma,j0,jc[3][3][i][k],1.);    /* Production */



/* Energy Crops Balances */

    j0=ir[1][0][13][k];

    for(i=0;i<5;i++) putmat(ma,j0,jc[3][3][i][k],1.);  /*Production*/

    for(i=6;i<9;i++) putmat(ma,j0,jc[5][4][i][k],-tdl[4]); /*Consumption*/

    putmat(ma,j0,jc[5][4][9][k],-1.);



/* Paper Scraps Balances */

    j0=ir[1][0][14][k];

    putmat(ma,j0,jc[3][3][18][k],1.);   /*Production*/

    for(i=10;i<12;i++) putmat(ma,j0,jc[5][4][i][k],-tdl[4]); /*Consumption*/

    putmat(ma,j0,jc[5][4][12][k],-1.);



/* Biomass Balances for Electric Fuel */

    j0=ir[1][0][15][k];

    putmat(ma,j0,jc[3][3][19][k],1.);  /* Black liquor */

    putmat(ma,j0,jc[3][3][20][k],1.);  /* Kitchen wastes */

    putmat(ma,j0,jc[3][3][21][k],1.);  /* Animal wastes */

    putmat(ma,j0,jc[5][4][12][k],1.);  /* Paper scraps */

    putmat(ma,j0,jc[5][4][13][k],1.);  /* Wood etc + Energy crops*/

    for(i=0;i<3;i++) putmat(ma,j0,jc[5][4][i][k],-tdl[4]); /* for Power*/



 /* Biomass Potentials */

    /* Energy crops */

    for(i=0;i<5;i++) {

      j0=ir[1][5][i][k];

      v=bio_share[n][i]*bio_productivity[n][0][ky0];

      putmat(ma,j0,jc[3][3][i][k],-1.); 

      putmat(ma,j0,jc[3][3][24][k],v);

    }

    /* Modern fuel woods */

    for(i=5;i<10;i++) {

      j0=ir[1][5][i][k];

      v=bio_share[n][i]*bio_productivity[n][1][ky0];

      putmat(ma,j0,jc[3][3][i][k],-1.); 

      if(v!=0.)

        putmat(ma,j0,jc[3][3][25][k],v); 

    }

    /* Wood residues and Sawmill residues */

    for(i=10;i<12;i++) {

      j0=ir[1][5][i][k];

      putmat(ma,j0,jc[3][3][i][k],-1.); 

      mb[j0]=-bio_potential[n][i-10][ky0]*bio_share[n][i];

    }

    /* Timber scraps (L)(M)(H)*/

    for(i=12;i<15;i++) {

      j0=ir[1][5][i][k];

      putmat(ma,j0,jc[3][3][i][k],-1.); 

      mb[j0]=-bio_potential[n][2][ky0]*bio_share[n][i];

    }

    /* Other biomass resources */

    for(i=15;i<24;i++) {

      j0=ir[1][5][i][k];

      putmat(ma,j0,jc[3][3][i][k],-1.); 

      mb[j0]=-bio_potential[n][i-12][ky0]*bio_share[n][i];

    }

    /* Arable Land area constraints */

    j0=ir[1][5][24][k];

    putmat(ma,j0,jc[3][3][24][k],-1.); 

    putmat(ma,j0,jc[3][3][25][k],-1.); 

    mb[j0]=-landarea[n][ky0];



/******************************************

          Wind Power Balance

*******************************************/

    j0=ir[1][0][8][k];

/* Consumption */

    for(i=0;i<2;i++) putmat(ma,j0,jc[5][6][i][k],-1.);

/* Production */

    putmat(ma,j0,jc[3][1][0][k],1.);



/******************************************

          Oil Product Balance

*******************************************/

    j0=ir[1][0][9][k];

    v=-reoils[n];

    u=1.+v;

    for(i=0;i<3;i++) putmat(ma,j0,jc[5][2][i][k],u);

    putmat(ma,j0,jc[5][2][3][k],v);

    putmat(ma,j0,jc[5][2][4][k],v);

    putmat(ma,j0,jc[5][2][5][k],u);



    for(i=0;i<3;i++)

      putmat(ma,j0,jc[5][7][i][k],u);

    putmat(ma,j0,jc[5][7][3][k],v);

    putmat(ma,j0,jc[5][7][4][k],v);

    putmat(ma,j0,jc[5][7][5][k],u);



    mb[j0]=-v*shfdsk[n][1]*demand[n][1][ky0];



/******************************************

           H2 Balance in IES

*******************************************/

    j0=ir[1][1][0][k];

    putmat(ma,j0,jc[7][0][0][k],-chcoef[JP_CH4_SY][0][ky0]);

    putmat(ma,j0,jc[7][0][1][k],-chcoef[JP_MEOH_S][0][ky0]);

    putmat(ma,j0,jc[7][0][8][k],-chcoef[JP_MEOH_D][0][ky0]);

    putmat(ma,j0,jc[7][0][2][k],-1.);

    putmat(ma,j0,jc[7][0][3][k],chcoef[JP_SHIFT][0][ky0]);

    putmat(ma,j0,jc[7][0][4][k],-1.);

    putmat(ma,j0,jc[7][0][5][k],1.);

    putmat(ma,j0,jc[5][1][3][k],chcoef[JP_NGAS_C][0][ky0]);

    putmat(ma,j0,jc[5][3][6][k],chcoef[JP_COAL_G][0][ky0]);

    putmat(ma,j0,jc[5][4][3][k],chcoef[JP_BIOM_G][0][ky0]);

    putmat(ma,j0,jc[5][4][11][k],chcoef[JP_BIOM_G][0][ky0]);



/******************************************

       Carbon Monoxide Balance in IES

*******************************************/

    j0=ir[1][1][1][k];

    putmat(ma,j0,jc[7][0][0][k],-chcoef[JP_CH4_SY][1][ky0]);

    putmat(ma,j0,jc[7][0][1][k],-chcoef[JP_MEOH_S][1][ky0]);

    putmat(ma,j0,jc[7][0][2][k],chcoef[JP_SHIFT][0][ky0]);

    putmat(ma,j0,jc[7][0][3][k],-1.);

    putmat(ma,j0,jc[5][1][3][k],chcoef[JP_NGAS_C][1][ky0]);

    putmat(ma,j0,jc[5][3][6][k],chcoef[JP_COAL_G][1][ky0]);

    putmat(ma,j0,jc[5][4][3][k],chcoef[JP_BIOM_G][1][ky0]);

    putmat(ma,j0,jc[5][4][11][k],chcoef[JP_BIOM_G][1][ky0]);



/******************************************

           CO2 Balance in IES

*******************************************/

    j0=ir[1][1][2][k];

    u=co2cef[6];

    putmat(ma,j0,jc[7][0][2][k],-chcoef[JP_SHIFT][0][ky0]*u);

    putmat(ma,j0,jc[7][0][3][k],u);

    putmat(ma,j0,jc[7][0][6][k],-1.);

    putmat(ma,j0,jc[7][0][7][k],1.);

    putmat(ma,j0,jc[7][0][8][k],-chcoef[JP_MEOH_D][1][ky0]);

    v=co2cef[1]-chcoef[JP_NGAS_C][1][ky0]*u;

    putmat(ma,j0,jc[5][1][3][k],v);

    v=co2cef[3]-chcoef[JP_COAL_G][1][ky0]*u;

    putmat(ma,j0,jc[5][3][6][k],v);

    v=co2cef[4]-chcoef[JP_BIOM_G][1][ky0]*u;

    putmat(ma,j0,jc[5][4][3][k],v);

    putmat(ma,j0,jc[5][4][11][k],v);



/**********************************************************************

       Recoverable CO2 Constraints in Electric Power Plants

***********************************************************************/

  for(i=0;i<3;i++) {

    j0=ir[1][2][i][k];

    putmat(ma,j0,jc[7][1][i][k],-1.);

    putmat(ma,j0,jc[5][1][i][k],co2cef[1]);

    putmat(ma,j0,jc[5][2][i][k],co2cef[2]);

    putmat(ma,j0,jc[5][7][i][k],co2cef[2]);

    putmat(ma,j0,jc[5][3][i][k],co2cef[3]);

    putmat(ma,j0,jc[5][4][i][k],co2cef[4]);

    putmat(ma,j0,jc[5][5][i][k],co2cef[5]);

  }



/******************************************

         Desulphur from Coal 

******************************************/

   /* Coal cleaning */

   j0=ir[1][3][0][k]; 

   for(i=0;i<3;i++) 

     putmat(ma,j0,jc[5][3][i][k],sulcef[0]);

   putmat(ma,j0,jc[7][4][0][k],-1./desulc[0][0]);



   /* FGD */

   j0=ir[1][3][1][k];

   for(i=0;i<3;i++) 

     putmat(ma,j0,jc[5][3][i][k],sulcef[0]);

   putmat(ma,j0,jc[7][4][0][k],-1.);

   for(i=1;i<4;i++)

     putmat(ma,j0,jc[7][4][i][k],-1./desulc[i][0]);



   /* Demand side (Coal cleaning) */

   j0=ir[1][3][2][k];

   putmat(ma,j0,jc[5][3][8][k],sulcef[0]);

   putmat(ma,j0,jc[7][5][0][k],-1./desulc[0][0]);



   /* Demand side (FGD) */

   j0=ir[1][3][3][k];

   putmat(ma,j0,jc[5][3][8][k],sulcef[0]);

   putmat(ma,j0,jc[7][5][0][k],-1.);

   for(i=1;i<3;i++)

     putmat(ma,j0,jc[7][5][i][k],-1./desulc[i][0]);



/******************************************

         Desulphur from Oil 

******************************************/

   /* Total */

   j0=ir[1][4][0][k];

   for(i=0;i<7;i++)

     putmat(ma,j0,jc[5][2][i][k],sulcef[1]);

   for(i=0;i<3;i++)

     putmat(ma,j0,jc[7][6][i][k],-1./desulc[i+1][0]);    

   putmat(ma,j0,jc[7][6][3][k],-1.);

   for(i=0;i<2;i++)

     putmat(ma,j0,jc[7][7][i][k],-1./desulc[i+1][0]);

   

   /* FGD */

   j0=ir[1][4][1][k];

   for(i=0;i<3;i++) 

     putmat(ma,j0,jc[5][2][i][k],sulcef[1]);

   for(i=0;i<3;i++)

     putmat(ma,j0,jc[7][6][i][k],-1./desulc[i+1][0]);   



   /* Demand side */

   j0=ir[1][4][2][k];

   putmat(ma,j0,jc[5][2][5][k],sulcef[1]);

   for(i=0;i<2;i++)

     putmat(ma,j0,jc[7][7][i][k],-1./desulc[i+1][0]); 



   /* Refinery */

   j0=ir[1][4][3][k];

   for(i=0;i<7;i++)

     putmat(ma,j0,jc[5][2][i][k],sulcef[1]);

   putmat(ma,j0,jc[7][6][3][k],-1./desulc[4][0]);



/******************************************

       Energy Balance in Demand side

*******************************************/

   for(i=0;i<N_DEM-1;i++)

     cdemak[n][i][k]=demand[n][i][ky0]*(1.-shfdsk[n][i]);

   cdemak[n][N_DEM-1][k]=demand[n][N_DEM-1][ky0];

   for(i=0;i<N_DEM;i++)  cdemak[n][i][k]*=(1.-sh_new_t[n][ky0]);

   for(i=0;i<N_DEM;i++)

     rdemak[n][i][k]=enepot[n][ky0]*cdemak[n][i][k];



/* Upper Limit */

   for(i=0;i<N_DEM;i++) {

     j0=ir[2][2][i][k];

     putmat(ma,j0,jc[6][0][i][k],-1.);

     mb[j0]=-cdemak[n][i][k]+rdemak[n][i][k];

   }



/* Gaseous Fuel */

    j0=ir[2][0][0][k];

    putmat(ma,j0,jc[3][3][22][k],chcoef[JP_BIOM_GA][0][ky0]);

    putmat(ma,j0,jc[3][3][23][k],chcoef[JP_BIOM_GA][0][ky0]);

    putmat(ma,j0,jc[5][0][3][k],1.);

    putmat(ma,j0,jc[5][1][4][k],1.);

    putmat(ma,j0,jc[6][0][0][k],-1.);

    mb[j0]=rdemak[n][0][k];



/* Gasoline */

    j0=ir[2][0][1][k];

    putmat(ma,j0,jc[5][2][3][k],1.);

    putmat(ma,j0,jc[5][7][3][k],1.);

    putmat(ma,j0,jc[5][4][6][k],chcoef[JP_BIOM_LF][0][ky0]);

    putmat(ma,j0,jc[5][5][3][k],chcoef[JP_MEOH_U][0][ky0]);

    putmat(ma,j0,jc[6][0][1][k],-oilsha[n][0][ky0]);

    mb[j0]=oilsha[n][0][ky0]*rdemak[n][1][k];



/* Light Liquid Fuel */

    j0=ir[2][0][2][k];

    putmat(ma,j0,jc[5][2][4][k],1.);

    putmat(ma,j0,jc[5][7][4][k],1.);

    putmat(ma,j0,jc[5][5][4][k],1.);

    putmat(ma,j0,jc[5][4][7][k],chcoef[JP_BIOM_LF][0][ky0]);

    putmat(ma,j0,jc[6][0][1][k],-oilsha[n][2][ky0]);

    mb[j0]=oilsha[n][2][ky0]*rdemak[n][1][k];



/* Heavy Liquid Fuel */

    j0=ir[2][0][3][k];

    putmat(ma,j0,jc[5][2][5][k],1.);

    putmat(ma,j0,jc[5][7][5][k],1.);

    putmat(ma,j0,jc[5][5][5][k],1.);

    putmat(ma,j0,jc[5][4][8][k],chcoef[JP_BIOM_LF][0][ky0]);

    putmat(ma,j0,jc[6][0][1][k],-oilsha[n][1][ky0]);

    mb[j0]=oilsha[n][1][ky0]*rdemak[n][1][k];



/* Solid Fuel */

    j0=ir[2][0][4][k];

    putmat(ma,j0,jc[5][3][8][k],1.);

    putmat(ma,j0,jc[5][4][5][k],1.);

    putmat(ma,j0,jc[5][4][10][k],1.);

    putmat(ma,j0,jc[6][0][2][k],-1.);

    mb[j0]=rdemak[n][2][k];

/*********************************************

              Electric Sector 

*********************************************/



/* Elec. Generation */



    for(l=0;l<3;l++) {

      j0=ir[2][1][l][k];

   /* Thermal power*/

      for(i=0;i<7;i++)

        for(j=l;j<3;j++)

          putmat(ma,j0,jc[9][i][j][k],elef[i]*elesh[j]);

   /* Synthesized oil fired power */

    for(j=l;j<3;j++)

            putmat(ma,j0,jc[9][8][j][k],elef[2]*elesh[j]);

   /* Hydro&Geothermal */

      putmat(ma,j0,jc[3][0][0][k],dshare[l]);

   /* Wind */

      putmat(ma,j0,jc[5][6][0][k],1./3.);

   /* Nuclear */

      putmat(ma,j0,jc[2][3][0][k],1./3.);

    }



   /* Photovoltaics */

    if(parele[n][2]!=0.0)

      putmat(ma,ir[2][1][0][k],jc[3][2][0][k],1.);

    else

      putmat(ma,ir[2][1][1][k],jc[3][2][0][k],1.);



/* Elec. Consumption */



   /* For Transportation */

    for(j=0;j<3;j++) {

      j0=ir[2][1][j][k];

      for(l=0;l<IINTER;l++)

        for(i=0;i<LR;i++) 

          if(tre[l][i]!=0.)

            putmat(ma,j0,jc[0][l][i][k],tre[l][i]);

    }



   /* Elec. for CO2 Disposal */

    for(j=0;j<3;j++) {

      for(i=0;i<N_DCO2-1;i++) putmat(ma,ir[2][1][j][k],jc[2][4][i][k],trd[0]);

      putmat(ma,ir[2][1][j][k],jc[2][4][N_DCO2-1][k],trd[1]);

    }



 /* Elec. for CO2 Recovery */

    for(i=0;i<3;i++) {

      j0=ir[2][1][i][k];

      for(j=i;j<3;j++)

        putmat(ma,j0,jc[7][1][j][k],-chcoef[JP_CO2R_C][1][ky0]*elesh[j]);

    }

 

 /* Elec. for Water Electrolysis */

    for(i=0;i<3;i++)

      putmat(ma,ir[2][1][i][k],jc[7][2][i][k],-tdl[6]);



 /* Elec. for Chemical Plants    */

    v=-1./3*tdl[6];

    for(i=0;i<3;i++) {

      j0=ir[2][1][i][k];

      putmat(ma,j0,jc[7][0][6][k], v*chcoef[JP_CO2R_P][1][ky0]);

      putmat(ma,j0,jc[5][1][3][k],v*chcoef[JP_NGAS_C][2][ky0]);

      putmat(ma,j0,jc[5][3][6][k],v*chcoef[JP_COAL_G][2][ky0]);

      putmat(ma,j0,jc[5][4][3][k], v*chcoef[JP_BIOM_G][2][ky0]);

      putmat(ma,j0,jc[5][4][11][k], v*chcoef[JP_BIOM_G][2][ky0]);

      putmat(ma,j0,jc[7][0][1][k], v*chcoef[JP_MEOH_S][2][ky0]);

      putmat(ma,j0,jc[7][0][8][k], v*chcoef[JP_MEOH_D][2][ky0]);

    }



 /* Elec. demand */

    for(i=0;i<3;i++) {

      j0=ir[2][1][i][k];

      v=dshare[i]*tdl[6];

      putmat(ma,j0,jc[6][0][3][k],-v);

      mb[j0]=rdemak[n][3][k]*v;

    }



 /* Elec. storage */

    j0=ir[2][1][0][k];

    i0=jc[7][3][0][k];

    v=elcoef[8][ky0];

    putmat(ma,j0,i0,-1.);

    putmat(ma,j0+2,i0,    v);

    putmat(ma,j0,  i0+1,-1.);

    putmat(ma,j0+1,i0+1,  v);

    putmat(ma,j0+1,i0+2,-1.);

    putmat(ma,j0,  i0+2,  v);

    putmat(ma,j0+1,i0+3,-1.);

    putmat(ma,j0+2,i0+3,  v);

    putmat(ma,j0+2,i0+4,-1.);

    putmat(ma,j0,  i0+4,  v);

    putmat(ma,j0+2,i0+5,-1.);

    putmat(ma,j0+1,i0+5,  v);



/************************************************

      Electricity Peak Supply Capability

*************************************************/

    j0=ir[2][1][3][k];

    u=3.*rpyt*(1.+parele[n][0]);



   /* For transportation */

    for(j=0;j<3;j++)

      for(i=0;i<LR;i++) {

        v=tre[j][i];

        if(v!=0.)

          putmat(ma,j0,jc[0][j][i][k],v*u);

      }



   /* For CO2 Disposal */

    for(i=0;i<N_DCO2-1;i++) putmat(ma,j0,jc[2][4][i][k],u*trd[0]);

    putmat(ma,j0,jc[2][4][N_DCO2-1][k],u*trd[1]);



   /* Elec. for Chemical Plants    */

    v=-rpyt*tdl[6];

    putmat(ma,j0,jc[7][0][6][k], v*chcoef[JP_CO2R_P][1][ky0]);

    putmat(ma,j0,jc[5][1][3][k],v*chcoef[JP_NGAS_C][2][ky0]);

    putmat(ma,j0,jc[5][3][6][k],v*chcoef[JP_COAL_G][2][ky0]);

    putmat(ma,j0,jc[5][4][3][k], v*chcoef[JP_BIOM_G][2][ky0]);

    putmat(ma,j0,jc[5][4][11][k], v*chcoef[JP_BIOM_G][2][ky0]);

    putmat(ma,j0,jc[7][0][1][k], v*chcoef[JP_MEOH_S][2][ky0]);

    putmat(ma,j0,jc[7][0][8][k], v*chcoef[JP_MEOH_D][2][ky0]);



   /* Demand */

    v=u/dsum*tdl[6];

    putmat(ma,j0,jc[6][0][3][k],-v);

    mb[j0]=rdemak[n][3][k]*v;



   /* Elec. from Renewable Energy */

    putmat(ma,j0,jc[3][0][0][k],dshare[0]*3.*rpyt);

    putmat(ma,j0,jc[5][6][0][k],rpyt);

    if(parele[n][2]!=0.)

      putmat(ma,j0,jc[3][2][0][k],3.*rpyt*parele[n][2]);



   /* Elec. from Thermal, Nuclear and Storage Power */

    for(i=0;i<9;i++)

      putmat(ma,j0,jc[8][0][i][k],plcost[i][0]);



    if(ky0>0 && dyr<thred)

      for(i=0;i<9;i++) putmat(ma,j0,jc[8][0][i][k1],plcost[i][0]);

    if(ky0>1 && ddyr<thred)

      for(i=0;i<9;i++) putmat(ma,j0,jc[8][0][i][k2],plcost[i][0]);



    if(ky0==0) 

      for(i=0;i<5;i++)

        mb[j0]-=plcost[iep[i]][0]*(cexist[n][i][0]+cexist[n][i][1]);

    if(ky0==1)

      for(i=0;i<5;i++)

        mb[j0]-=plcost[iep[i]][0]*cexist[n][i][0];



/*******************************************

    Capacities of Electric Power Plants

*******************************************/

/* Thermal Power Plants */

   for(i=0;i<7;i++) {

     j0=ir[3][0][i][k];

     putmat(ma,j0,jc[8][0][i][k],1.);

     v=elef[i]*rpyt/plcost[i][0];

     for(j=0;j<3;j++)

       putmat(ma,j0,jc[9][i][j][k],-3.*v*elesh[j]);

   }

   /* Synthesized oil power plant */

   j0=ir[3][0][2][k];

   v=elef[2]*rpyt/plcost[2][0];

   for(j=0;j<3;j++)

     putmat(ma,j0,jc[9][8][j][k],-3.*v*elesh[j]);



/* Nuclear Power */

   j0=ir[3][0][7][k];

   putmat(ma,j0,jc[8][0][7][k],1.);

   v=rpyt/plcost[7][0];

   putmat(ma,j0,jc[2][3][0][k],-v);



/* Electricity Storage */

   j0=ir[3][0][8][k];

   putmat(ma,j0,jc[8][0][8][k],1.);

   v=rpyt/parele[n][1];

   for(i=0;i<6;i++)

     putmat(ma,j0,jc[7][3][i][k],-v);



   if(ky0==0) 

     for(i=0;i<5;i++)

       mb[ir[3][0][iep[i]][k]]=-cexist[n][i][0]-cexist[n][i][1];

   if(ky0==1)

     for(i=0;i<5;i++)

       mb[ir[3][0][iep[i]][k]]=-cexist[n][i][0];



   if(ky0>0 && dyr<thred)

     for(i=0;i<9;i++) putmat(ma,ir[3][0][i][k],jc[8][0][i][k1],1.);

   if(ky0>1 && ddyr<thred)

     for(i=0;i<9;i++) putmat(ma,ir[3][0][i][k],jc[8][0][i][k2],1.);



/******************************************

        Capacities of Chemical Plants

*******************************************/





   /* Oil refi. distil */

    j0=ir[3][1][0][k];

    v=-1./plcost[9][0]/chcoef[JP_OIL_DI][0][ky0];

    for(i=0;i<6;i++)

      if(i!=3) {

        putmat(ma,j0,jc[5][2][i][k],v);

        putmat(ma,j0,jc[5][7][i][k],v);

      }

    putmat(ma,j0,jc[5][2][3][k],v/chcoef[JP_OIL_GA][0][ky0]

                              *chcoef[JP_OIL_DI][0][ky0]);

    putmat(ma,j0,jc[5][7][3][k],v/chcoef[JP_OIL_GA][0][ky0]

                               *chcoef[JP_OIL_DI][0][ky0]);

    if(ky0==0)

      mb[j0]=-cexist[n][5][0]-cexist[n][5][1];

    if(ky0==1)

      mb[j0]=-cexist[n][5][0];



   /* Oil refi. gasoline */

    j0=ir[3][1][1][k];

    putmat(ma,j0,jc[5][2][3][k],-1./plcost[10][0]);

    putmat(ma,j0,jc[5][7][3][k],-1./plcost[10][0]);

    if(ky0==0)

      mb[j0]=-cexist[n][6][0]-cexist[n][6][1];

    if(ky0==1)

      mb[j0]=-cexist[n][6][0];



   /* N.G. splitting */

    putmat(ma,ir[3][1][2][k],jc[5][1][3][k],-1./plcost[11][0]);

   /* Coal gasification */

    putmat(ma,ir[3][1][3][k],jc[5][3][6][k],-1./plcost[12][0]);

   /* Coal liquefaction */

    putmat(ma,ir[3][1][4][k],jc[5][3][7][k],-1./plcost[13][0]);

   /* Bio. gasif(Pyroly) */

    putmat(ma,ir[3][1][5][k],jc[5][4][3][k],-1./plcost[14][0]); /*Wood etc*/

    putmat(ma,ir[3][1][5][k],jc[5][4][11][k],-1./plcost[14][0]);/*Paper*/

   /* Bio. lique(Synthe) */

    putmat(ma,ir[3][1][6][k],jc[5][4][4][k],-1./plcost[15][0]);

   /* Methane synth. */

    putmat(ma,ir[3][1][7][k],jc[7][0][0][k],-1./plcost[16][0]);

   /* MeOH synth. (CO) */

    putmat(ma,ir[3][1][8][k],jc[7][0][1][k],-1./plcost[17][0]);

   /* MeOH synth. (CO2) */

    putmat(ma,ir[3][1][9][k],jc[7][0][8][k],-1./plcost[18][0]);





   /* Shift converter */

    j0=ir[3][1][10][k];

    v=-1./plcost[19][0];

    putmat(ma,j0,jc[5][1][3][k],v);

    putmat(ma,j0,jc[5][3][6][k],v);

    putmat(ma,j0,jc[5][4][3][k],v);

    putmat(ma,j0,jc[5][4][11][k],v);

    putmat(ma,j0,jc[7][0][5][k],v);



   /* Mobile method */

    putmat(ma,ir[3][1][11][k],jc[5][5][3][k],-1./plcost[20][0]);



   /* Electrolysis */

    v=wel/plcost[21][0];

    for(i=0;i<3;i++) {

      j0=ir[3][1][12+i][k];

      putmat(ma,j0,jc[7][2][i][k],-3.*v);

      putmat(ma,j0,jc[5][6][1][k],-v);

    }



   /* CO2 recovery (Ch) */

    j0=ir[3][1][15][k];

    v=1./plcost[22][0];

    putmat(ma,j0,jc[7][1][0][k],-3.*v);

    putmat(ma,j0,jc[7][1][1][k],-1.5*v);

    putmat(ma,j0,jc[7][1][2][k],-v);



   /* CO2 recovery (Ph) */

    putmat(ma,ir[3][1][16][k],jc[7][0][6][k],-1./plcost[23][0]);



    /*Bio. gasif(Anaero) */

    putmat(ma,ir[3][1][17][k],jc[3][3][22][k],-1./plcost[27][0]);

    putmat(ma,ir[3][1][17][k],jc[3][3][23][k],-1./plcost[27][0]);



    /*Bio. lique(Fermen) */

    putmat(ma,ir[3][1][18][k],jc[5][4][6][k],-1./plcost[28][0]);

    putmat(ma,ir[3][1][18][k],jc[5][4][7][k],-1./plcost[28][0]);

    putmat(ma,ir[3][1][18][k],jc[5][4][8][k],-1./plcost[28][0]);



    for(i=0;i<19;i++)

      putmat(ma,ir[3][1][i][k],jc[8][1][ich[i]][k],1.);



    if(ky0>0 && dyr<thred) 

      for(i=0;i<19;i++) putmat(ma,ir[3][1][i][k],jc[8][1][ich[i]][k1],1.);

    if(ky0>1 && ddyr<thred) 

      for(i=0;i<19;i++) putmat(ma,ir[3][1][i][k],jc[8][1][ich[i]][k2],1.);



/******************************************

        Constraints in Electric Power Sector 

*******************************************/

  /* Upper Limit for Nuclear */

    j0=ir[4][0][0][k];

    putmat(ma,j0,jc[8][0][7][k],-1.);

    mb[j0]=-scnucl[n][ky0];

    if(ky0==0)

      mb[j0]+=cexist[n][3][0]+cexist[n][3][1];

    if(ky0==1)

      mb[j0]+=cexist[n][3][0];



    if(ky0>0 && dyr<thred)  putmat(ma,j0,jc[8][0][7][k1],-1.);

    if(ky0>1 && ddyr<thred) putmat(ma,j0,jc[8][0][7][k2],-1.);



  /* Upper Limit for Electricity Storage */

    j0=ir[4][0][1][k];

    putmat(ma,j0,jc[8][0][8][k],-1.);

    v=3.*rpyt*(1.+parele[n][0])*tdl[6]/dsum*parele[n][3];

    putmat(ma,j0,jc[6][0][3][k],v);

    mb[j0]=-v*rdemak[n][3][k];



    if(ky0==0) mb[j0]+=cexist[n][4][0]+cexist[n][4][1];

    if(ky0==1) mb[j0]+=cexist[n][4][0];



    if(ky0>0 && dyr<thred)  putmat(ma,j0,jc[8][0][8][k1],-1.);

    if(ky0>1 && ddyr<thred) putmat(ma,j0,jc[8][0][8][k2],-1.);



  /* Upperl Limit for Photovoltaics in Elec.*/

    j0=ir[4][0][2][k];

    putmat(ma,j0,jc[3][2][0][k],-1.);

    v=parele[n][5]*tdl[6];

    if(parele[n][2]!=0.0) {

      putmat(ma,j0,jc[6][0][3][k],dshare[0]*v);

      putmat(ma,j0,jc[7][3][0][k],1.);

      putmat(ma,j0,jc[7][3][1][k],1.);

      putmat(ma,j0,jc[7][2][0][k],1.);

      mb[j0]=-dshare[0]*rdemak[n][3][k]*v;

    }

    else {

      putmat(ma,j0,jc[6][0][3][k],dshare[1]*v);

      putmat(ma,j0,jc[7][3][2][k],1.);

      putmat(ma,j0,jc[7][3][3][k],1.);

      putmat(ma,j0,jc[7][2][1][k],1.);

      mb[j0]=-dshare[1]*rdemak[n][3][k]*v;

    }



  /* Upper Limit for Wind Power in Elec. */

    j0=ir[4][0][3][k];

    putmat(ma,j0,jc[5][6][0][k],-1.);

    v=parele[n][6]*tdl[6];

    putmat(ma,j0,jc[6][0][3][k],v);

    mb[j0]=-v*rdemak[n][3][k];



  /* Photovoltaic Potential */

    j0=ir[4][0][4][k];

    putmat(ma,j0,jc[3][2][0][k],-1.);

    mb[j0]=-rgrade[n][2][0];



  /* Upper Limit for the Growth of CO2 Chemical Recovery */

    j0=ir[4][0][5][k];

    v=co2upp/1000.*dyr;

    for(i=0;i<3;i++) {

      putmat(ma,j0,jc[5][1][i][k],co2cef[1]*v);

      putmat(ma,j0,jc[5][2][i][k],co2cef[2]*v);

      putmat(ma,j0,jc[5][3][i][k],co2cef[3]*v);

      putmat(ma,j0,jc[5][4][i][k],co2cef[4]*v);

      putmat(ma,j0,jc[5][5][i][k],co2cef[5]*v);

      putmat(ma,j0,jc[7][1][i][k],-1.);

    }

    if(ky0>0)

      for(i=0;i<3;i++) putmat(ma,j0,jc[7][1][i][k1],1.);



  /* Upper Limit for the Growth of Hydro&Geothermal Power Plant */

    j0=ir[4][0][6][k];

    v=parele[n][4]*tdl[6]/10.*dyr;

    putmat(ma,j0,jc[3][0][0][k],-1.);

    putmat(ma,j0,jc[6][0][3][k],v);

    mb[j0]=-rdemak[n][3][k]*v;

      

    if(ky0==0) mb[j0]-=currpr[n][3];

    else putmat(ma,j0,jc[3][0][0][k1],1.);



  /* Lower Limit for Nuclear Shares in Elec. */

    j0=ir[4][0][7][k];

    if(misncl[n][ky0]>0.01) {

      putmat(ma,j0,jc[2][3][0][k],1.);

      v=misncl[n][ky0]*tdl[6];

      putmat(ma,j0,jc[6][0][3][k],-v);

      mb[j0]=v*rdemak[n][3][k];

    }



  /* Upper Limit for Oil Fired Power Plant */

    j0=ir[4][0][8][k];

    putmat(ma,j0,jc[8][0][2][k],-1.);



    if(ky0==0)

      mb[j0]=-oilgenplt_max[n][k]+cexist[n][1][0]+cexist[n][1][1];

    else if(ky0==1)

      mb[j0]=-oilgenplt_max[n][k]+cexist[n][1][0];

    else

      mb[j0]=-oilgenplt_max[n][k];



    if(ky0>0 && dyr<thred)  putmat(ma,j0,jc[8][0][2][k1],-1.);

    if(ky0>1 && ddyr<thred) putmat(ma,j0,jc[8][0][2][k2],-1.);



/******************************************

        Growth and Decline constraints

*******************************************/



  /* Upper Limit for the Change in Fossil Fuels Production */



    for(i=0;i<N_FOS;i++) {

      v=pow(1.+upplmt[i]/100.,dyr);

      j0=ir[5][0][i][k];

      for(j=0;j<N_EGRADE;j++) putmat(ma,j0,jc[2][i][j][k],-1.);

      if(ky0==0) mb[j0]=-v*currpr[n][i];

      else for(j=0;j<N_EGRADE;j++) putmat(ma,j0,jc[2][i][j][k1],v);

    }



  /* Lower Limit for the Change in Fossil Fuels Production */



    for(i=0;i<N_FOS;i++) {

      v=pow(1.-lowlmt[i]/100.,dyr);

      j0=ir[5][1][i][k];

      for(j=0;j<N_EGRADE;j++) putmat(ma,j0,jc[2][i][j][k],1.);

      if(ky0==0) mb[j0]=v*currpr[n][i];

      else for(j=0;j<N_EGRADE;j++) putmat(ma,j0,jc[2][i][j][k1],-v);

    }



  /* Lower Limit for the Change in Renewable Energy Production */



    for(i=0;i<N_REN-1;i++) {

      v=pow(1.-lowlmt[i+N_FOS]/100.,dyr);

      j0=ir[5][2][i][k];

      putmat(ma,j0,jc[3][i][0][k],1.);

      if(ky0==0) {if(i<2) mb[j0]=v*currpr[n][i+N_FOS];}

      else  putmat(ma,j0,jc[3][i][0][k1],-v);

    }



  /* Lower Limit for the Change in Electricity Generation */



    for(i=0;i<7;i++)

      for(j=0;j<3;j++) putmat(ma,ir[4][1][i][k],jc[9][i][j][k],elef[i]);

    for(j=0;j<3;j++) putmat(ma,ir[4][1][2][k],jc[9][8][j][k],elef[2]);   

    putmat(ma,ir[4][1][7][k],jc[2][3][0][k],1.);

    if(k1>=0) {

      for(i=0;i<7;i++) {

        v=pow(1.-deprrt[0][i]/100.,dyr);

        for(j=0;j<3;j++) putmat(ma,ir[4][1][i][k],jc[9][i][j][k1],-elef[i]*v);

      }

      v=pow(1.-deprrt[0][2]/100.,dyr);

      for(j=0;j<3;j++) putmat(ma,ir[4][1][2][k],jc[9][8][j][k1],-elef[2]*v);   

      v=pow(1.-deprrt[0][7]/100.,dyr);

      putmat(ma,ir[4][1][7][k],jc[2][3][0][k1],-v);

    }

    else 

      for(i=0;i<4;i++) {

        v=pow(1.-deprrt[0][iep[i]]/100.,dyr);

        mb[ir[4][1][iep[i]][k]]=v*ele_2000[n][i];

      }



  /* Lower Limit for the Absolute Amount of Electricity Generated */



    for(i=0;i<3;i++) {

      for(j=0;j<3;j++) 

        putmat(ma,ir[4][2][i][k],jc[9][i+1][j][k],elef[i+1]);

      mb[ir[4][2][i][k]]=ele_min[n][i][ky0];

    }

    for(j=0;j<3;j++) 

      putmat(ma,ir[4][2][1][k],jc[9][8][j][k],elef[2]);

    putmat(ma,ir[4][2][3][k],jc[2][3][0][k],1.);

    mb[ir[4][2][3][k]]=ele_min[n][3][ky0];





  /* Lower Limit for the Change in Energy Consumption in End-use */



    for(i=0;i<10;i++)

      putmat(ma,ir[5][4][i][k],jc[9][7][i][k],1.);

    for(i=0;i<3;i++)

      putmat(ma,ir[5][4][2+i][k],jc[9][7][10+i][k],1.);



    if(k1>=0) {

      /* Gaseous */

      for(i=0;i<2;i++) {

        v=pow(1.-deprrt[1][i]/100.,dyr);

        if(cdemak[n][0][k]<cdemak[n][0][k1]) 

    v*=cdemak[n][0][k]/cdemak[n][0][k1];

        putmat(ma,ir[5][4][i][k],jc[9][7][i][k1],-v);

      }

      /* Oil Prod. */

      for(i=2;i<5;i++) {

        v=pow(1.-deprrt[1][i]/100.,dyr);

        if(cdemak[n][1][k]<cdemak[n][1][k1]) 

    v*=cdemak[n][1][k]/cdemak[n][1][k1];

        putmat(ma,ir[5][4][i][k],jc[9][7][i][k1],-v);

      }

      /* Solid */

      for(i=5;i<7;i++) {

        v=pow(1.-deprrt[1][i]/100.,dyr);

        if(cdemak[n][2][k]<cdemak[n][2][k1])

    v*=cdemak[n][2][k]/cdemak[n][2][k1];

        putmat(ma,ir[5][4][i][k],jc[9][7][i][k1],-v);

      }



      /* Methanol*/

      for(i=7;i<10;i++) {

        v=pow(1.-deprrt[1][i]/100.,dyr);

        if(cdemak[n][1][k]<cdemak[n][1][k1]) 

    v*=cdemak[n][1][k]/cdemak[n][1][k1];

        putmat(ma,ir[5][4][i][k],jc[9][7][i][k1],-v);

      }

      /* Syn. oil*/

      for(i=0;i<3;i++) {

        v=pow(1.-deprrt[1][2+i]/100.,dyr);

        if(cdemak[n][1][k]<cdemak[n][1][k1]) 

    v*=cdemak[n][1][k]/cdemak[n][1][k1];

        putmat(ma,ir[5][4][2+i][k],jc[9][7][10+i][k1],-v);

      }

    }

    else {

      mb[ir[5][4][1][k]]=dem_2000[n][0];

      mb[ir[5][4][2][k]]=dem_2000[n][1]*oilsha[n][0][ky0];

      mb[ir[5][4][3][k]]=dem_2000[n][1]*oilsha[n][2][ky0];

      mb[ir[5][4][4][k]]=dem_2000[n][1]*oilsha[n][1][ky0];

      mb[ir[5][4][5][k]]=dem_2000[n][2];

 

      v=pow(1.-deprrt[1][1]/100.,dyr);

      if(cdemak[n][0][k]<dem_2000[n][0]) v*=cdemak[n][0][k]/dem_2000[n][0];

      mb[ir[5][4][1][k]]*=v;



      for(i=2;i<5;i++) {

        v=pow(1.-deprrt[1][i]/100.,dyr);

        if(cdemak[n][1][k]<dem_2000[n][1]) v*=cdemak[n][1][k]/dem_2000[n][1];

        mb[ir[5][4][i][k]]*=v;

      }

      v=pow(1.-deprrt[1][5]/100.,dyr);

      if(cdemak[n][2][k]<dem_2000[n][2]) v*=cdemak[n][2][k]/dem_2000[n][2];

      mb[ir[5][4][5][k]]*=v;



    }



  /* Upper Limit for the Change in Reforestation */



    j0=ir[5][3][0][k];

    for(i=0;i<N_REFO;i++) putmat(ma,j0,jc[2][5][i][k],-1.);

    if(dyr<thred) mb[j0]=-dyr*refore[n][1]*ref_cap/100./30.;

    else          mb[j0]=-refore[n][1]*ref_cap/100.;



/******************************************

         CO2 Emissions Constraint

*******************************************/

    if(ictrl3==1) {

      j0=ir[6][0][0][k];

      putmat(ma,j0,jc[1][3][0][k],-1.);

      putmat(ma,j0,jc[1][3][1][k],1.);

      putmat(ma,j0,jc[1][4][0][k],-1.);

      putmat(ma,j0,jc[1][4][1][k],1.);

      putmat(ma,j0,jc[6][1][0][k],-1.);

      putmat(ma,j0,jc[6][1][1][k],1.);

      i=0;

      while(n_sc[i][k]==0) {i++;}

      mb[j0]=-cem_2000[n]*co2reg[n][i][ky0]/100.;

    }



/******************************************

         Temperature Rise Constraint

*******************************************/

    j0=ir[6][0][1][k];

    putmat(ma,j0,jc[6][2][0][k],-1.);

    putmat(ma,j0,jc[6][2][1][k],1.);

    i=0;

    while(n_sc[i][k]==0) {i++;}

    if(ictrl5==1&&temper[i][ky0]>=0.)  mb[j0]=-temper[i][ky0]*1.e5;

    else mb[j0]=-1.e6;



/******************************************

        Sulphur Emissions Constraint 

*******************************************/

   if(ictrl10==1){

     j0=ir[6][0][5][k]; 

     putmat(ma,j0,jc[6][4][0][k],-1.);

     i=0;

     while(n_sc[i][k]==0) {i++;}

     mb[j0]=-sulreg[n][i][ky0];

   }



/******************************************

          Maxium Flow Costraints

*******************************************/

      j0=ir[6][0][2][k];

      for(i=0;i<IINTER;i++)

         for(j=0;j<LR;j++) putmat(ma,j0,jc[0][i][j][k],-1.);



      for(i=0;i<ITRANS;i++) {

         putmat(ma,j0,jc[1][i][0][k],-1.);

         putmat(ma,j0,jc[1][i][1][k],-1.);

       }

      putmat(ma,j0,jc[2][4][N_DCO2-1][k],-1.);

      putmat(ma,j0,jc[6][1][0][k],-1.);

      putmat(ma,j0,jc[6][1][1][k],-1.);

      mb[j0]=-(demand[n][0][ky0]+demand[n][1][ky0]+demand[n][2][ky0]

                 +demand[n][3][ky0]/0.4/etcon)*30.;



/********************************************************

   Fossil Fuel Production and CO2 Subterranean Disposal

*********************************************************/

   v=dyr;

   if(ky0<(N_TMP-1))  v+=n_yr[ky0+1]-n_yr[ky0];

   v/=20.;



   u=dyr/2.;

   i=ky0;

   while(i<N_TMP-1&&n_yr[i+1]-n_yr[ky0]<thred) {u+=n_yr[i+1]-n_yr[i++];}

   if(i<(N_TMP-1))  u+=(n_yr[i+1]-n_yr[i])/2.;

   u/=10.;



   for(l=0;l<N_SCE;l++) {

     if(n_sc[l][k]==1) {



 /* Fossil Fuel Production */

       for(i=0;i<N_FOS;i++) 

         for(j=0;j<N_EGRADE;j++) {

             j0=ir[0][i][j][l];

             putmat(ma,j0,jc[2][i][j][k],-v);

      }



 /* CO2 Disposal */

       for(i=0;i<N_DCO2-1;i++) {

         j0=ir[0][4][i][l];

         putmat(ma,j0,jc[2][4][i][k],-v);

       }

       j0=ir[0][4][2][l];

       for(i=0;i<N_EGRADE-2;i++)  /* Excluding of additional occurence */

         putmat(ma,j0,jc[2][0][i][k],v/co2sub[1]);



 /* Reforestation */

       for(i=0;i<N_REFO;i++) {

         j0=ir[0][5][i][l];

         putmat(ma,j0,jc[2][5][i][k],-u);

       }



     }

   }

/********************************************************

   Capital Stock Growth Equation and Upper and Lower Limits

*********************************************************/

   rkap[n][k]=kap_low[n][ky0]*kap0[n][ky0];

   kapk[n][k]=kap0[n][ky0];



   /* State Equation */

   j0=ir[6][0][3][k];

   putmat(ma,j0,jc[6][3][0][k],1.);

   putmat(ma,j0,jc[6][3][1][k],-dis_i2[n][ky0]);

   if(k1!=-1) {

     putmat(ma,j0,jc[6][3][0][k1],-dis_i3[n][ky0]);

     putmat(ma,j0,jc[6][3][1][k1],-dis_i1[n][ky0]);

     mb[j0]=dis_i3[n][ky0]*rkap[n][k1]-rkap[n][k];

   }

   else

     mb[j0]=(dis_i3[n][ky0]*mepm[n][2]+dis_i1[n][ky0]*ivs_2000[n])

           *gdp_2000[n]/1000.-rkap[n][k];



  /* Upper Limit */

   j0=ir[6][0][4][k];

   putmat(ma,j0,jc[6][3][0][k],-1.);

   mb[j0]=(kap_low[n][ky0]-kap_up[n][ky0])*kap0[n][ky0];

  }



 /* end for k loop */



  for(l=0;l<N_SCE;l++) {

    for(i=0;i<N_FOS;i++) {

      v=currpr[n][i]*0.5;

      for(j=0;j<N_EGRADE;j++) {

        mb[ir[0][i][j][l]]=-egrade[n][i][j]*100.;

        if(v>0.) {

          mb[ir[0][i][j][l]]+=v;

          if(mb[ir[0][i][j][l]]>0.) {

            v=mb[ir[0][i][j][l]];

            mb[ir[0][i][j][l]]=0.;

    }

          else v=0.;

  }

      }

    }



    mb[ir[0][4][0][l]]=-co2cap[n][0]*50.;

    mb[ir[0][4][1][l]]=-co2cap[n][0]*50.;

    mb[ir[0][4][2][l]]=-co2cap[n][1]*100.;

    mb[ir[0][4][3][l]]=-co2cap[n][2]*100.;

    mb[ir[0][4][4][l]]=-co2cap[n][3]*100.;

    mb[ir[0][4][5][l]]=-co2cap[n][4]*100.;

    mb[ir[0][4][6][l]]=-co2cap[n][5]*100.;

    mb[ir[0][4][7][l]]=-co2cap[n][6]*100.;

    for(i=0;i<N_REFO;i++)

      mb[ir[0][5][i][l]]=-refore[n][0]*refore[n][i+2]/10.;

  }



  free(elef);

  free(tdl);

  free(tre);

  free(trf);  

}





  void make_cost(n,mc)

  int n;

  double *mc;

{ int i,j,k,ky0;

  double v,u,tc[11][2],zdf,zdp,dyr,ctax,sum_ec,stax;



  for(i=0;i<JC;i++) mc[i]=0.;



  f_off_set[n]=0.;



  if(ictrl1)

    for(k=0;k<N_TMP;k++) 

      for(i=0;i<N_DEM;i++)

        dispri[n][i][k]=enepri[n][i]-shdpri[n][i][0];



  for(k=0;k<N_BLK;k++) {

    ky0=n_tm[k];



    dyr=n_yr[ky0]-start_yr;

    zdf=dis_f[ky0]*prob_k[k];

    zdp=dis_p[ky0]*prob_k[k];



    ctax=0.;

    if(ictrl2==1) {

      i=0;

      while(n_sc[i][k]==0) {i++;}

      ctax=co2tax[n][i][ky0];

    }

    stax=0.;

    if(ictrl9==1) {

      i=0;

      while(n_sc[i][k]==0) {i++;}

      stax=sultax[n][i][ky0];

    }



 /* Transportation Cost */



    for(i=0;i<10;i++) {

      v=pow(1.-trcost[i][2],dyr);

      tc[i][0]=trcost[i][0]*v;

      tc[i][1]=trcost[i][1]*v;

    }



    for(i=0;i<IINTER;i++) {

      v=pow(1.-plcost[24+i][3],dyr)*plcost[24+i][1]

       *plcost[24+i][2]/plcost[24+i][0]/365.;

      tc[2*i][0]+=v;

    }

    tc[9][0]+=v; /* CO2 Ocean Disposal */



    for(i=0;i<LR;i++) 

      if(i!=n) {

        for(j=0;j<IINTER;j++) {

          v=tc[2*j][1]*trocea[n][i]+tc[2*j+1][1]*trland[n][i];

          if(trocea[n][i]!=0.) v+=tc[2*j][0];

          if(trland[n][i]!=0.) v+=tc[2*j+1][0];

          mc[jc[0][j][i][k]]=v;

  }

      }



    for(i=0;i<3;i++) mc[jc[1][i][0][k]]=tc[6+i][0];

    mc[jc[1][5][0][k]]=tc[6][0];



    if(ictrl3==1) {

      mc[jc[1][3][0][k]]=co2tran[n][0][ky0]/2.+ctax;

      mc[jc[1][3][1][k]]=co2tran[n][0][ky0]/2.-ctax;

      mc[jc[1][4][0][k]]=co2tran[n][1][ky0]/2.+ctax;

      mc[jc[1][4][1][k]]=co2tran[n][1][ky0]/2.-ctax;

    }

    else {

      mc[jc[1][3][0][k]]=9.e4;

      mc[jc[1][3][1][k]]=9.e4;

      mc[jc[1][4][0][k]]=9.e4;

      mc[jc[1][4][1][k]]=9.e4;

    }



    for(i=0;i<LR;i++) {

      if(i!=n) {

        mc[jc[0][0][i][k]]+=profit[n][0][ky0];

        mc[jc[0][1][i][k]]+=profit[n][1][ky0];

      }

      else {

        mc[jc[0][0][i][k]]=tariff[n][0][ky0];

        mc[jc[0][1][i][k]]=tariff[n][1][ky0];

      }

    }



    mc[jc[1][0][0][k]]+=profit[n][2][ky0];

    mc[jc[1][5][0][k]]+=profit[n][2][ky0];

    mc[jc[1][1][0][k]]+=profit[n][3][ky0];

    mc[jc[1][2][0][k]]+=profit[n][4][ky0];



    mc[jc[1][0][1][k]]=tariff[n][2][ky0];

    mc[jc[1][5][1][k]]=tariff[n][2][ky0];

    mc[jc[1][1][1][k]]=tariff[n][3][ky0];

    mc[jc[1][2][1][k]]=tariff[n][4][ky0];



/* Plant Construction Costs */

    for(i=0;i<9;i++) {

      v=pow(1.-plcost[i][3],dyr);

      u=plcost[i][4];

      if(u==0.)      v*=rlcost[0][n][ky0];

      else if(u==1.) v*=rlcost[1][n][ky0];

      else if(u==2.) v*=rlcost[2][n][ky0];

      else if(u==3.) v*=rlcost[3][n][ky0];

      else if(u==4.) v*=rlcost[4][n][ky0];

      else if(u==5.) v*=rlcost[5][n][ky0];

      else if(u==6.) v*=rlcost[6][n][ky0];

      else if(u==7.) v*=rlcost[7][n][ky0];

      else if(u==8.) v*=rlcost[8][n][ky0];

      else if(u==9.) v*=rlcost[9][n][ky0];

      else {

        printf(" Please Check 'plcost[i][4]'.\n");

        exit(0);

      }

      mc[jc[8][0][i][k]]+=plcost[i][1]*plcost[i][2]*v*zdp;

    }

    for(i=0;i<15;i++) {

      v=pow(1.-plcost[i+9][3],dyr);

      u=plcost[i+9][4];

      if(u==0.)      v*=rlcost[0][n][ky0];

      else if(u==1.) v*=rlcost[1][n][ky0];

      else if(u==2.) v*=rlcost[2][n][ky0];

      else if(u==3.) v*=rlcost[3][n][ky0];

      else if(u==4.) v*=rlcost[4][n][ky0];

      else if(u==5.) v*=rlcost[5][n][ky0];

      else if(u==6.) v*=rlcost[6][n][ky0];

      else if(u==7.) v*=rlcost[7][n][ky0];

      else if(u==8.) v*=rlcost[8][n][ky0];

      else if(u==9.) v*=rlcost[9][n][ky0];

      else {

        printf(" Please Check 'plcost[i][4]'.\n");

        exit(0);

      }

      mc[jc[8][1][i][k]]+=plcost[i+9][1]*plcost[i+9][2]*v/365.*zdp;

    }

    for(i=18;i<20;i++) {

      v=pow(1.-plcost[i+9][3],dyr);

      u=plcost[i+9][4];

      if(u==0.)      v*=rlcost[0][n][ky0];

      else if(u==1.) v*=rlcost[1][n][ky0];

      else if(u==2.) v*=rlcost[2][n][ky0];

      else if(u==3.) v*=rlcost[3][n][ky0];

      else if(u==4.) v*=rlcost[4][n][ky0];

      else if(u==5.) v*=rlcost[5][n][ky0];

      else if(u==6.) v*=rlcost[6][n][ky0];

      else if(u==7.) v*=rlcost[7][n][ky0];

      else if(u==8.) v*=rlcost[8][n][ky0];

      else if(u==9.) v*=rlcost[9][n][ky0];

      else {

        printf(" Please Check 'plcost[i][4]'.\n");

        exit(0);

      }

      mc[jc[8][1][i-3][k]]+=plcost[i+9][1]*plcost[i+9][2]*v/365.*zdp;

    }



/* Fossil Fuel Production Costs */

    for(i=0;i<N_FOS;i++)

      for(j=0;j<N_EGRADE;j++)

         mc[jc[2][i][j][k]]=epcost[i][j]-subsid[n][i][ky0]+royalt[n][i][ky0];



/* Linear term of Renewable Energy */

    for(i=0;i<N_REN;i++)

      mc[jc[3][i][0][k]]=-subsid[n][i+N_FOS][ky0];



/* Biomass Energy Production */

    v=pow(1.-acrdrt[3][0],n_yr[0]-start_yr);

    for(j=1;j<=ky0;j++) v*=pow(1.-acrdrt[3][j],n_yr[j]-n_yr[j-1]);

    for(i=0;i<24;i++) mc[jc[3][3][i][k]]+=bio_cost[n][i]*v;



/* Photovoltaics */

    v=pow(1.-acrdrt[2][0],n_yr[0]-start_yr);

    for(j=1;j<=ky0;j++) v*=pow(1.-acrdrt[2][j],n_yr[j]-n_yr[j-1]);

    mc[jc[3][2][0][k]]+=rpcost[n][2][0]*v;



/* Nuclear Power */

    mc[jc[2][3][0][k]]=nclrct[ky0];



/* CO2 Disposal */

    v=tc[5][1]*trnco2[n][0];

    if(trnco2[n][0]!=0.) v+=tc[5][0];

    for(i=0;i<N_DCO2-1;i++)

      mc[jc[2][4][i][k]]=v+co2cst[n][i];



    v=tc[5][1]*trnco2[n][1]+tc[9][1]*trnco2[n][2];

    if(trnco2[n][1]!=0.) v+=tc[5][0];

    if(trnco2[n][2]!=0.) v+=tc[9][0];

    mc[jc[2][4][N_DCO2-1][k]]=v+co2cst[n][N_DCO2-1];



/* Desulphur Costs */

    for(i=0;i<4;i++)

      mc[jc[7][4][i][k]]=desulc[i][1];

    for(i=0;i<3;i++)

      mc[jc[7][5][i][k]]=desuld[i];



    for(i=0;i<4;i++)

      mc[jc[7][6][i][k]]=desulc[i+1][1];

    for(i=0;i<2;i++)

      mc[jc[7][7][i][k]]=desuld[i+1];



/* Sulphur Tax */

    mc[jc[6][4][0][k]]=stax;



/* Reforestation */

    for(i=0;i<N_REFO;i++)

      mc[jc[2][5][i][k]]=refore[n][5+i];



/* Energy Distribution Costs */

    for(i=0;i<N_DEM;i++) 

      mc[jc[6][0][i][k]]=dispri[n][i][ky0];



/* CO2 Tax */

    mc[jc[6][1][0][k]]=ctax;

    mc[jc[6][1][1][k]]=-ctax;





/* Discounting */

    for(i=0;i<IINTER;i++)

      for(j=0;j<LR;j++) mc[jc[0][i][j][k]]*=zdf;

    for(i=0;i<ITRANS;i++) mc[jc[1][i][0][k]]*=zdf;

    for(i=0;i<ITRANS;i++) mc[jc[1][i][1][k]]*=zdf;

    for(i=0;i<N_FOS;i++)

      for(j=0;j<N_EGRADE;j++) mc[jc[2][i][j][k]]*=zdf;

    for(i=0;i<24;i++) mc[jc[3][3][i][k]]*=zdf;

    for(i=0;i<N_REN-1;i++) mc[jc[3][i][0][k]]*=zdf;

    mc[jc[2][3][0][k]]*=zdf;

    for(i=0;i<N_DCO2;i++) mc[jc[2][4][i][k]]*=zdf;

    for(i=0;i<N_DEM;i++) mc[jc[6][0][i][k]]*=zdf;

    for(i=0;i<2;i++)  mc[jc[6][1][i][k]]*=zdf;

    for(i=0;i<N_REFO;i++) mc[jc[2][5][i][k]]*=zdp;

    for(i=0;i<4;i++) mc[jc[7][4][i][k]]*=zdf;

    for(i=0;i<3;i++) mc[jc[7][5][i][k]]*=zdf;

    for(i=0;i<4;i++) mc[jc[7][6][i][k]]*=zdf;

    for(i=0;i<2;i++) mc[jc[7][7][i][k]]*=zdf;

    mc[jc[6][4][0][k]]*=zdf;



/* Renewable Energy Production Costs */

    for(i=0;i<N_REN-2;i++) {

      v=pow(1.-acrdrt[i][0],n_yr[0]-start_yr);

      for(j=1;j<=ky0;j++) v*=pow(1.-acrdrt[i][j],n_yr[j]-n_yr[j-1]);

      for(j=0;j<N_RGRADE+1;j++)

        rpck[n][i][j][k]=rpcost[n][i][j]*v*zdf;

      slope_f[n][i][0][k]=0.;

      for(j=1;j<N_RGRADE;j++)

        slope_f[n][i][j][k]=slope_f[n][i][j-1][k]

            +(rpck[n][i][j][k]+rpck[n][i][j-1][k])*rgdk[n][i][j-1]/2.;

      for(j=0;j<N_RGRADE;j++)

        slope_df[n][i][j][k]

           =(rpck[n][i][j+1][k]-rpck[n][i][j][k])/rgdk[n][i][j]/2.;

    }



/*  Annual Investment */



   mc[jc[6][3][1][k]]=1000.*dis_inv[n][ky0]*prob_k[k];

   if(ky0==N_TMP-1)

     mc[jc[6][3][0][k]]=1000.*(mepm[n][0]+discnt[ky0]-1./dis_i2[n][ky0])*zdf;

   prod_a[n][k]=0.;

   prod_c[n][k]=0.;

   for(i=0;i<N_DEM;i++) prod_b[n][i][k]=0.;

   for(i=0;i<N_DEM;i++) enecon_f[n][i][k]=0.;



   if(ictrl1) {

     if(ictrl8==0) {



/* Energy Conservation Utility Functions */

        for(i=0;i<N_DEM;i++)

          enecon_f[n][i][k]=cdemak[n][i][k]/(1.+prelas[n][i])

                          *(shdpri[n][i][ky0]+dispri[n][i][ky0])*zdf;

      }

      else {

/* Macro Economic Production Function */

        sum_ec=0.;

        for(i=0;i<N_DEM;i++) {

          v=cdemak[n][i][k]*(shdpri[n][i][ky0]+dispri[n][i][ky0]);

          prod_b[n][i][k]=v;

          sum_ec+=v;

        }



        for(i=0;i<N_DEM;i++) prod_b[n][i][k]/=sum_ec;

        u=sum_ec/gdp0[n][ky0];

        prod_c[n][k]=klelas[n]*kap0[n][ky0]*1000.*(mepm[n][0]+discnt[ky0])

                     /(gdp0[n][ky0]*(1.-u));

        v=pow(gdp0[n][ky0]*zdf,klelas[n]);

        prod_a[n][k]=(1.-u)*v;

        v=pow(u*v,enelas[n]/klelas[n]);

        for(i=0;i<N_DEM;i++) prod_b[n][i][k]*=v;

    for(i=0;i<N_DEM;i++) enecon_f[n][i][k]=0.;

    }

   }



/* Damage Function */



   if(ictrl7)

     damage[n][k]=zdf*gdp0[n][ky0]*mepm[n][4]/100./pow(2.5*1.e5,mepm[n][5]);

   else

     damage[n][k]=0.;



/* Off-set */

    v=0.;

    v-=inv0[n][ky0]*dis_inv[n][ky0]*prob_k[k];

    if(ky0==N_TMP-1)

      v-=(kap0[n][ky0]-rkap[n][k])*1000

      *(mepm[n][0]+discnt[ky0]-1./dis_i2[n][ky0])*zdf;

    if(ictrl8) v+=gdp0[n][ky0]*zdf;

    f_off_set[n]+=v;

  }

}





  void putmat(ppt,i,j,v)

  struct mat **ppt;

  int i,j;

  double v;

{ struct mat *pt,*pt0,*pt1;



  if(i==-1) return;

  if(v==0.) printf(" Zero input %d %d\n",i,j);



  pt=ppt[j];

  pt0=NULL;

  while(pt!=NULL&&pt->row<i) {

    pt0=pt;

    pt=pt->next;

  }

  if(pt==NULL||pt->row!=i) {

    if(NULL==(pt1=(struct mat *) malloc(sizeof(struct mat)))) {

      printf(" There is no enough memory!!\n");

      exit(0);

    }

    pt1->next=pt;

    pt1->row=i;

    pt1->val=v;

  }

  else {

    printf(" Matrix was overwritten at Var. %d costr. %d\n",j,i);

    pt->val=v;

  }

  if(pt0==NULL) ppt[j]=pt1;

  else       pt0->next=pt1;

}















